package Ranks
{
	function GameConnection::autoAdminCheck(%client)
	{
		%client.oldPrefix = %client.clanPrefix;
		%client.oldSuffix = %client.clanSuffix;
		%client.firstSpawn = true;
		return Parent::autoAdminCheck(%client);
	}

	function GameConnection::onClientEnterGame(%client)
	{
		Parent::onClientEnterGame(%client);

		if(isFile("config/server/Ranks/" @ %client.BL_ID @ ".txt"))
		{
			%fw = new FileObject();
			%fw.openForRead("config/server/Ranks/" @ %client.BL_ID @ ".txt");
			%name = %fw.readLine();
			%client.setScore(%fw.readLine());
			%client.killCount = %fw.readLine();
			%client.rank = %fw.readLine();
			%client.lastRank = %client.rank;
			%fw.close();
			%fw.delete();

			%client.schedule(1000, "RankLoop");
		}
	}

	function GameConnection::onClientLeaveGame(%client)
	{
		%fw = new FileObject();
		%fw.openForWrite("config/server/Ranks/" @ %client.BL_ID @ ".txt");
		%fw.writeLine(%client.getPlayerName());
		%fw.writeLine(%client.score);
		%fw.writeLine(%client.killCount);
		%fw.writeLine(%client.rank);
		%fw.close();
		%fw.delete();
	
		Parent::onClientLeaveGame(%client);
	}

	function GameConnection::spawnPlayer(%client)
	{
		%ret = Parent::spawnPlayer(%client);
		%client.schedule(100, "SetRank");
		return %ret;
	}

	function GameConnection::onDeath(%client, %killerPlayer, %killer, %damageType, %damageLoc)
	{
		Parent::onDeath(%client, %killerPlayer, %killer, %damageType, %damageLoc);

		%victim = %client;

		if(%victim != %killer)
			%killer.killCount ++;

		%killer.schedule(100, "SetRank");
	}
	function GameConnection::incScore(%client, %amount)
	{
		Parent::incScore(%client, %amount);
		%client.schedule(100, "SetRank");
	}
};
activatePackage(Ranks);

function GameConnection::SetRank(%client)
{
	if(!$Pref::Ranks::Enabled)
	{
		%client.clanPrefix = %client.oldPrefix;
		return;
	}

	%pre = "<color:666666>[<color:FFFFFF>";
	%suf = "<color:666666>]";

	if(%client.rank $= "") %client.rank = 0;
	if(%client.rank < 0) %client.rank = 0;
	if(%client.rank > $Rank::TitleMax) %client.rank = $Rank::TitleMax;

	if($Pref::Ranks::Type == 2)
	{
		if(%client.clanPrefix == %client.oldPrefix)
			%client.clanprefix = %pre @ $Rank::Title[%client.rank] @ %suf;
		return;
	}

	%diff = $Pref::Ranks::Difficulty;
	%type = 1-$Pref::Ranks::Type/2;
	%media = $Pref::Ranks::Controller ? %client.killCount : %client.score;

	%client.rank = mFloor(mPow(%media,%type)/%diff);

	if(%client.rank <= $Rank::TitleMax)
		%client.clanprefix = %pre @ $Rank::Title[%client.rank] @ %suf;
	else
		%client.clanprefix = %pre @ %client.rank @ %suf;

	if(%client.lastRank != %client.rank)
	{
		%player = %client.player;
		if(isObject(%player) && %player.getState() !$= "Dead")
		{
			if(!%client.firstSpawn)
			{
				if(%client.lastRank < %client.rank)
				{
					messageClient(%client,'',"<color:00FF00>You've been promoted!");
					serverplay3d(rewardSound,%player.getHackPosition());
					%player.emote(winStarProjectile,1);
				}
				else
				{
					messageClient(%client,'',"<color:FF0000>You've been demoted!");
					serverplay3d(Beep_No_Sound,%player.getHackPosition());
				}
			}
			else
				%client.firstSpawn = false;
		}
		%client.lastRank = %client.rank;
	}
}

function serverCMDsetRank(%client, %amount, %name)
{
	if(!%client.isAdmin)
		return;

	if($Pref::Ranks::Type != 2)
	{
		messageClient(%client,'',"\c5Please enable \c3Manual \c5Ranking before using this command");
		return;
	}

	if(!$Pref::Ranks::Enabled)
	{
		messageClient(%client,'',"\c5Please enable \c3Ranks \c5before using this command");
		return;
	}

	if(%name !$= "")
	{
		if(findClientByName(%name))
			%target = findClientByName(%name);
		else if(findClientByBL_ID(%name))
			%target = findClientByBL_ID(%name);
		else
		{
			messageClient(%client,'',"\c3" @ %name @ "\c5 is not a valid Name or BL_ID");
			return;
		}
	}
	else
	{
		%name = %client.getPlayerName();
		%target = %client;
	}

	if(!isObject(%target))
	{
		messageClient(%client,'',"\c3" @ %name @ "\c5 is not a valid Name or BL_ID");
		return;
	}

	if(%amount < 0 || mFloor(%amount) != %amount)
		messageClient(%client,'',"\c5Please use a non-negative integer");
	else if(%amount > $Rank::TitleMax)
		messageClient(%client,'',"\c5Please use a number less than \c3" @ $Rank::TitleMax);

	if(%target.rank == %amount)
	{
		messageClient(%client,'',"\c5Please use a number different from the current rank");
		return;
	}

	%target.clanprefix = "<color:666666>[<color:FFFFFF>" @ $Rank::Title[%amount] @ "<color:666666>]";

	if(%target != %client)
	{
		messageClient(%client,'',"\c3You \c5have set \c3" @ %target.getPlayerName() @ "\c5's Rank to \c3" @ %amount @ "\c5 (\c3" @ $Rank::Title[%amount] @ "\c5)");
		messageClient(%target,'',"\c3" @ %client.getPlayerName() @ "\c5 has set \c3 your\c5 Rank to \c3" @ %amount @ "\c5 (\c3" @ $Rank::Title[%amount] @ "\c5)");
	}
	else
		messageClient(%client,'',"\c3You \c5have set\c3 your\c5 Rank to \c3" @ %amount @ "\c5 (\c3" @ $Rank::Title[%amount] @ "\c5)");
}

%i = 0;
$Rank::Title[%i] = "Recruit"; %i++;
$Rank::Title[%i] = "Apprentice I"; %i++;
$Rank::Title[%i] = "Apprentice II"; %i++;
$Rank::Title[%i] = "Private I"; %i++;
$Rank::Title[%i] = "Private II"; %i++;
$Rank::Title[%i] = "Specialist I"; %i++;
$Rank::Title[%i] = "Specialist II"; %i++;
$Rank::Title[%i] = "Corporal I"; %i++;
$Rank::Title[%i] = "Corporal II"; %i++;
$Rank::Title[%i] = "Sergeant I"; %i++;
$Rank::Title[%i] = "Sergeant II"; %i++;
$Rank::Title[%i] = "Sergeant III"; %i++;
$Rank::Title[%i] = "Officer I"; %i++;
$Rank::Title[%i] = "Officer II"; %i++;
$Rank::Title[%i] = "Officer III"; %i++;
$Rank::Title[%i] = "Officer IV"; %i++;
$Rank::Title[%i] = "Lieutenant I"; %i++;
$Rank::Title[%i] = "Lieutenant II"; %i++;
$Rank::Title[%i] = "Lieutenant III"; %i++;
$Rank::Title[%i] = "Lieutenant IV"; %i++;
$Rank::Title[%i] = "Captain I"; %i++;
$Rank::Title[%i] = "Captain II"; %i++;
$Rank::Title[%i] = "Captain III"; %i++;
$Rank::Title[%i] = "Captain IV"; %i++;
$Rank::Title[%i] = "Major I"; %i++;
$Rank::Title[%i] = "Major II"; %i++;
$Rank::Title[%i] = "Major III"; %i++;
$Rank::Title[%i] = "Major IV"; %i++;
$Rank::Title[%i] = "Commander I"; %i++;
$Rank::Title[%i] = "Commander II"; %i++;
$Rank::Title[%i] = "Commander III"; %i++;
$Rank::Title[%i] = "Commander IV"; %i++;
$Rank::Title[%i] = "Colonel I"; %i++;
$Rank::Title[%i] = "Colonel II"; %i++;
$Rank::Title[%i] = "Colonel III"; %i++;
$Rank::Title[%i] = "Colonel IV"; %i++;
$Rank::Title[%i] = "Brigadier I"; %i++;
$Rank::Title[%i] = "Brigadier II"; %i++;
$Rank::Title[%i] = "Brigadier III"; %i++;
$Rank::Title[%i] = "Brigadier IV"; %i++;
$Rank::Title[%i] = "General I"; %i++;
$Rank::Title[%i] = "General II"; %i++;
$Rank::Title[%i] = "General III"; %i++;
$Rank::Title[%i] = "General IV"; %i++;
$Rank::Title[%i] = "Marshall I"; %i++;
$Rank::Title[%i] = "Marshall II"; %i++;
$Rank::Title[%i] = "Marshall III"; %i++;
$Rank::Title[%i] = "Marshall IV"; %i++;
$Rank::Title[%i] = "Guardian I"; %i++;
$Rank::Title[%i] = "Guardian II"; %i++;
$Rank::Title[%i] = "Guardian III"; %i++;
$Rank::Title[%i] = "Guardian IV"; %i++;
$Rank::Title[%i] = "Guardian V"; %i++;
$Rank::Title[%i] = "Conqueror I"; %i++;
$Rank::Title[%i] = "Conqueror II"; %i++;
$Rank::Title[%i] = "Conqueror III"; %i++;
$Rank::Title[%i] = "Conqueror IV"; %i++;
$Rank::Title[%i] = "Conqueror V"; %i++;
$Rank::Title[%i] = "War Hero I"; %i++;
$Rank::Title[%i] = "War Hero II"; %i++;
$Rank::Title[%i] = "War Hero III"; %i++;
$Rank::Title[%i] = "War Hero IV"; %i++;
$Rank::Title[%i] = "War Hero V"; %i++;
$Rank::Title[%i] = "Destroyer I"; %i++;
$Rank::Title[%i] = "Destroyer II"; %i++;
$Rank::Title[%i] = "Destroyer III"; %i++;
$Rank::Title[%i] = "Destroyer IV"; %i++;
$Rank::Title[%i] = "Destroyer V"; %i++;
$Rank::Title[%i] = "Annihilator I"; %i++;
$Rank::Title[%i] = "Annihilator II"; %i++;
$Rank::Title[%i] = "Annihilator III"; %i++;
$Rank::Title[%i] = "Annihilator IV"; %i++;
$Rank::Title[%i] = "Annihilator V"; %i++;
$Rank::Title[%i] = "Juggernaut I"; %i++;
$Rank::Title[%i] = "Juggernaut II"; %i++;
$Rank::Title[%i] = "Juggernaut III"; %i++;
$Rank::Title[%i] = "Juggernaut IV"; %i++;
$Rank::Title[%i] = "Juggernaut V"; %i++;
$Rank::Title[%i] = "Legend I"; %i++;
$Rank::Title[%i] = "Legend II"; %i++;
$Rank::Title[%i] = "Legend III"; %i++;
$Rank::Title[%i] = "Legend IV"; %i++;
$Rank::Title[%i] = "Legend V"; %i++;
$Rank::Title[%i] = "Fable I"; %i++;
$Rank::Title[%i] = "Fable II"; %i++;
$Rank::Title[%i] = "Fable III"; %i++;
$Rank::Title[%i] = "Fable IV"; %i++;
$Rank::Title[%i] = "Fable V"; %i++;
$Rank::Title[%i] = "Forerunner I"; %i++;
$Rank::Title[%i] = "Forerunner II"; %i++;
$Rank::Title[%i] = "Forerunner III"; %i++;
$Rank::Title[%i] = "Forerunner IV"; %i++;
$Rank::Title[%i] = "Forerunner V"; %i++;
$Rank::Title[%i] = "Deity I"; %i++;
$Rank::Title[%i] = "Deity II"; %i++;
$Rank::Title[%i] = "Deity III"; %i++;
$Rank::Title[%i] = "Deity IV"; %i++;
$Rank::Title[%i] = "Deity V"; %i++;
$Rank::Title[%i] = "God of War";
$Rank::TitleMax = %i;